<?php
/**********************************************************************************
* RemoteAuth.php                                                               *
***********************************************************************************
* SMF: Simple Machines Forum                                                      *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
* =============================================================================== *
* Software Version:           SMF 2.0 RC1                                      *
* Software by:                Simple Machines (http://www.simplemachines.org)     *
* Copyright 2006-2008 by:     Simple Machines LLC (http://www.simplemachines.org) *
*           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
* Support, News, Updates at:  http://www.simplemachines.org                       *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the provided license as published by Simple Machines LLC.          *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the "license.txt" file for details of the Simple Machines license.          *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');
	
/*	This file helps the administrator setting external authentication settings and policy
	as well as allow the SMF to register new members themselves.
	
	void verifyExternalUser
		- verify the external user 
		
	bool synchronizePassword (bool = ID_MEMBER)
		- synchronize the external password to SMF
	
	void getExternalPassword
		- get the password from external database
		
	migrateExternalUser
		- migrate the external user to SMF

*/

// we start with the hook
define('SMF_INTEGRATION_SETTINGS',serialize(array(
	'integrate_verify_user' => 'integrate_verify_user',
	'integrate_verify_password' => 'integrate_verify_password',
	'integrate_register' => 'integrate_register',
	'integrate_validate_login' => 'integrate_validate_login',
	'integrate_pre_load' => 'integrate_pre_load',
	'integrate_reset_pass' => 'integrate_reset_pass')));


function integrate_verify_password($memberName, $password)
{
	global $modSettings;
	
	// member already authenticated against a webserver? we can ignore their password
	if (isset($_SERVER['PHP_AUTH_PW']) && $modSettings['auth_type'] == 1 && !empty($modSettings['externalAuth']))
	{
		$password = $_SERVER['PHP_AUTH_PW'];
		//integrate_reset_passwd($memberName, $password);
		return  (verifyExternalUser() && $memberName == $remoteUser);
	}
	return false;	
}


function integrate_reset_passwd($memberName, $password)
{
	return;
}

function integrate_verify_user()
{
    global $db_prefix, $smcFunc, $modSettings, $context, $sourcedir;
	
	//require_once($sourcedir . '/Subs-Members.php');
		
	if($modSettings['auth_type'] == '1' && !empty($modSettings['externalAuth']))
	{
		
		if (verifyExternalUser()) 
		{
			//Kerberos? - drop  the KDC  & cleanup  member_name
			if (strstr($_SERVER['REMOTE_USER'],'@'))
			{
				$remoteUser = $smcFunc['strtolower'](preg_replace('~(&#(\\d{1,7}|x[0-9a-fA-F]{1,6});)~','',(preg_replace('/@.*/', '', $_SERVER['REMOTE_USER']))));
				$realName = preg_replace( '/@.*/', '', $_SERVER['REMOTE_USER']);
			}
			//NTLM ? drop AD domain, the backslash & cleanup member_name
			elseif (strstr($_SERVER['REMOTE_USER'],'\\'))
			{
				$remoteUser = $smcFunc['strtolower'](preg_replace('~(&#(\\d{1,7}|x[0-9a-fA-F]{1,6});)~','',(substr(strrchr($_SERVER['REMOTE_USER'], '\\'),1))));
				$realName = substr(strrchr($_SERVER['REMOTE_USER'], '\\'),1);
			}
			//Basic auth ( auth_lap, auth_basic)? clean member_name
			else 
			{
				$remoteUser = $smcFunc['strtolower'](preg_replace('~(&#(\\d{1,7}|x[0-9a-fA-F]{1,6});)~','', $_SERVER['REMOTE_USER']));
				$realName = $_SERVER['REMOTE_USER']; 
			}	
			// user already in the members table?
			if (!isReservedName($remoteUser, 0, false)) 
				$id_member = migrateExternalUser($remoteUser, 0, 0);
		
			else 
			{
				// user found, get id_member
				$request = $smcFunc['db_query']('', '
						SELECT id_member, passwd, password_salt
						FROM {db_prefix}members
						WHERE member_name = {string:member_name}
						LIMIT 1',
					array(
						'member_name' => $remoteUser,
						)
				);
									
				list ($id_member, $password, $salt) = $smcFunc['db_fetch_row']($request);
				$smcFunc['db_free_result']($request);
				
				//Remote password and SMF password the same?
				if (isset($_SERVER['PHP_AUTH_PW']))
				{	
					$sha_passwd = sha1(strtolower($remoteUser) . un_htmlspecialchars($_SERVER['PHP_AUTH_PW']));
					if($password != $sha_passwd)
					{
						//new remote password set? update smf_member
						$user_settings['id_member'] = $id_member;
						$user_settings['passwd'] = $sha_passwd;
						$user_settings['password_salt'] = substr(md5(rand()), 0, 4);
						updateMemberData($user_settings['id_member'], array('passwd' => $user_settings['passwd'], 'password_salt' => $user_settings['password_salt']));
					}
				}
			}
			return($id_member);
		}
		else 
			return(false);			
	} 
}


function integrate_register($options, $theme) 
{
	return;
}


function integrate_validate_login($username, $password, $cookietime){

	global $smcFunc, $context, $modSettings, $authentication_settings, $id_member, $other_passwords;
	
	if($modSettings['auth_type'] == '2' && !empty($modSettings['externalAuth']))	
	{	
		// Check if the user already exists in SMF.
		$request = $smcFunc['db_query']('', '
						SELECT id_member
						FROM {db_prefix}members
						WHERE member_name = {string:member_name}',
					array(
						'member_name' => $_REQUEST['user'],
						)
				);
			
		list ($id_member) = $smcFunc['db_fetch_row']($request);
		
		//collect the data from our external database 
		$request = $smcFunc['db_query']('', '
						SELECT ' . ($modSettings['auth_field_username'] ? $modSettings['auth_field_username'] : '') . '
						' . ($modSettings['auth_field_password'] ? (', '. $modSettings['auth_field_password']) : '') . '
						' . ($modSettings['auth_field_mailadress'] ? (', '. $modSettings['auth_field_mailadress']) : '') . '
						' . ($modSettings['auth_field_passwordsalt'] ? (', '. $modSettings['auth_field_passwordsalt']) : '') . '
						FROM `'. $modSettings['auth_database'] . '`.' . $modSettings['auth_table'] . '
						WHERE ' . $modSettings['auth_field_username'] . ' = {string:authusername}' . '
						LIMIT 1',
					array(
						'authusername' => $_REQUEST['user'],
						)
				);
				
		if (!empty($modSettings['auth_field_passwordsalt']))
			list ($authentication_settings['username'], $authentication_settings['password'], $authentication_settings['email'], $authentication_settings['salt']) = $smcFunc['db_fetch_row']($request);
		else
			list ($authentication_settings['username'], $authentication_settings['password'], $authentication_settings['email']) = $smcFunc['db_fetch_row']($request);
				
								
		if(isset($id_member) && isset($authentication_settings['username']))
		{	
			synchronizePassword($id_member);
			return false;
		}
		//User is SMF only, no password synchronization possible
		elseif(isset($id_member) && empty($authentication_settings['username']))
			return false;
		
		//OK, no user in SMF.  Does this user exist in the external table?
		elseif(isset($authentication_settings['username']))
			verifyExternalUser();
		
		$smcFunc['db_free_result']($request);
		
	}
}


function integrate_pre_load ()
{
	global $context;
	
	$context['disable_login_hashing'] = true;
}

function verifyExternalUser ()
{
	global $smcFunc, $context, $modSettings, $authentication_settings, $other_passwords, $sourcedir;
	
	require_once($sourcedir . '/Subs-Members.php');
	
	if ($modSettings['auth_type'] == 2 && !empty($modSettings['externalAuth']))
	{
		getExternalPassword();
		//compare the specified password with our passwords array
		if(in_array($authentication_settings['password'], $other_passwords))
		{
			//no SMF user until yet? make him SMF!
			migrateExternalUser($authentication_settings['username'], $authentication_settings['password'], $authentication_settings['email']);			
			return (true);
		}
	}
	elseif ($modSettings['auth_type'] == 1 && !empty($modSettings['externalAuth']))
		//Webserver mode - easy work for now ;-)
		return (isset($_SERVER['AUTH_TYPE']) ? isset($_SERVER['REMOTE_USER']) : false);
	else
		return (false);

}


function synchronizePassword ($id_member)
{
	global $smcFunc, $context, $modSettings, $id_member, $authentication_settings;
	global $sourcedir, $user_info, $other_passwords;
	
	require_once($sourcedir . '/Subs-Members.php');
	getExternalPassword();
	if(isset($id_member)) 
	{
		$sha_passwd = sha1(strtolower($authentication_settings['username']) . un_htmlspecialchars($_POST['passwrd']));
		
		if (in_array($authentication_settings['password'], $other_passwords)) 
		{
			if($authentication_settings['password'] != $sha_passwd)
			{				
				$user_settings['id_member'] = $id_member;
				$user_settings['passwd'] = $sha_passwd;	
				$user_settings['password_salt'] = substr(md5(mt_rand()), 0, 4);

				// Update the password and set the hash.
				updateMemberData($user_settings['id_member'], array('passwd' => $user_settings['passwd'], 'password_salt' => $user_settings['password_salt']));
				return(true);
			}	
		}
		
		else 
		return (false);
	}
}

function getExternalPassword ()
{
	global $user_info, $txt, $context, $smcFunc, $modSettings, $authentication_settings, $other_passwords;
	
	//define some useful arrays
	$other_passwords = array();
	$authentication_settings = array();
	
	//collect the data from our external database 
	$request = $smcFunc['db_query']('', '
						SELECT ' . ($modSettings['auth_field_username'] ? $modSettings['auth_field_username'] : '') . '
						' . ($modSettings['auth_field_password'] ? (', '. $modSettings['auth_field_password']) : '') . '
						' . ($modSettings['auth_field_mailadress'] ? (', '. $modSettings['auth_field_mailadress']) : '') . '
						' . ($modSettings['auth_field_passwordsalt'] ? (', '. $modSettings['auth_field_passwordsalt']) : '') . '
						FROM `'. $modSettings['auth_database'] . '`.' . $modSettings['auth_table'] . '
						WHERE ' . $modSettings['auth_field_username'] . ' = {string:authusername}' . '
						LIMIT 1',
					array(
						'authusername' => $_REQUEST['user'],
						)
				);
				
		if (!empty($modSettings['auth_field_passwordsalt']))
			list ($authentication_settings['username'], $authentication_settings['password'], $authentication_settings['email'], $authentication_settings['salt']) = $smcFunc['db_fetch_row']($request);
		else
			list ($authentication_settings['username'], $authentication_settings['password'], $authentication_settings['email']) = $smcFunc['db_fetch_row']($request);
				
		//check the minimum requirements first
		if(!empty($authentication_settings['username']) && !empty($authentication_settings['password']) && !empty($authentication_settings['email']))
		{
			//first the ones without salt
			$other_passwords[] = md5($_POST['passwrd']);
			$other_passwords[] = sha1($_POST['passwrd']);
			$other_passwords[] = md5(md5($_POST['passwrd']));
			$other_passwords[] = $_POST['passwrd'];
			$other_passwords[] = crypt($_POST['passwrd'], $authentication_settings['password']);
			$other_passwords[] = crypt($_POST['passwrd']);
			
			//new Joomla  password?
			$inline_salt   = explode( ':', $authentication_settings['password'] );
			if(isset($inline_salt['1']))
				$other_passwords[] = md5($_POST['passwrd'] . $inline_salt['1']) . ':' . $inline_salt['1'];
			
			//now the more secure passwords with a salt
			if(isset($authentication_settings['salt']))
			{
				$other_passwords[] = sha1(strtolower($authentication_settings['username']) . un_htmlspecialchars($_POST['passwrd']));
				$other_passwords[] = sha1($authentication_settings['salt'] . $_POST['passwrd']);
				$other_passwords[] = sha1($authentication_settings['salt'] . $_POST['passwrd']);
				$other_passwords[] = md5($authentication_settings['salt'] . $_POST['passwrd']);
				$other_passwords[] = md5($_POST['passwrd'] . $authentication_settings['salt']);
			}
			
		}
}


function migrateExternalUser ($username, $password, $email)
{	
	global $user_info, $txt, $context, $smcFunc, $modSettings, $sourcedir;
	
	require_once($sourcedir . '/Subs-Members.php');
	
	if ($modSettings['auth_type'] == 1 && !empty($modSettings['externalAuth']))
	{
		//check for the $_SERVER['PHP_AUTH_PW']) and take it if possible...
		if (isset($_SERVER['PHP_AUTH_PW']))
			$password = $_SERVER['PHP_AUTH_PW'];
		// no $_SERVER['PHP_AUTH_PW']) found (NTLM or Kerberos Ticket?), let's create a secure random password based on Subs-Members.php.
		else 
		{
			srand(time() + 1277);
			$password = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
		}	
				
		//Is our new user an Admin?
		if(isset($modSettings['auth_admins']))
		{
			$new_admin = explode(',', $modSettings['auth_admins']);
			$new_admin = $smcFunc['htmltrim']($new_admin);
			if (in_array($username, $new_admin))
				$group = 1;
		}
	
		//set privileges, only Admins  can register new members
		$user_info['is_guest'] = false;
		$user_info['is_admin'] = true;
	
		$regOptions = array(
			'interface' => 'admin',
			'username' => $username,
			'email' => preg_replace('/[^a-zA-Z0-9\.\-]/','',$username) . $modSettings['auth_maildomain'],
			'password' => $password,
			'password_check' => $password,
			'check_reserved_name' => true,
			'getExternalPassword_strength' => false,
			'check_email_ban' => false,
			'send_welcome_email' => '',
			'real_name' => isset($AUTHENTICATE_SAMACCOUNTNAME) ? $AUTHENTICATE_SAMACCOUNTNAME : $username,
			'memberGroup' => isset($group) ? '1' : '0',
			'require' => 'nothing',
			);
		$id_member = registerMember($regOptions);
		return($id_member);
	}
	
	if($modSettings['auth_type'] == 2 && !empty($modSettings['externalAuth']))
	{
		//set privileges, only Admins  can register new members
		$user_info['is_guest'] = false;
		$user_info['is_admin'] = true;
	
		//Is our new user an Admin?
		if(isset($modSettings['auth_admins']))
		{
			$new_admin = explode(',', $modSettings['auth_admins']);
			$new_admin = $smcFunc['htmltrim']($new_admin);
			if (in_array($username, $new_admin))
				$group = 1;
		}
		
		$regOptions = array(
			'interface' => 'admin',
			'username' => $username,
			'email' => $email,
			'password' => $_POST['passwrd'],
			'password_check' => $_POST['passwrd'],
			'check_reserved_name' => true,
			'getExternalPassword_strength' => false,
			'check_email_ban' => false,
			'send_welcome_email' => '',
			'real_name' => $username,
			'memberGroup' => isset($group) ? '1' : '0',
			'require' => 'nothing',
		);
		$id_member = registerMember($regOptions);
		return($id_member);
		}
}
?>